#!/usr/bin/env python
# -*- coding: utf-8 -*-
# report bugs to: riverfor@sina.com.cn
"""
Test target module: compass.common.response.agentservice
"""

from compass.common.error import SUCCESS
from compass.test.agentserver.base import AgentServerTestCase

class ServiceForResponseTestCase(AgentServerTestCase):
    """
    this part is the response to the request of the service's operation
    """
    def testServiceNotify(self):
        """
	"""
	packet = self.client.data_packed('service_notify', \
	                                 ('service_id', 'sn001'), \
					 ('level', 0x0002), \
					 ('weight', 0x003), \
					 ('status', 'D'))
	self._socketDone(packet)
	sbag, cbag = self.server.messages[0], self.client.messages[0]
	self.assertEquals(sbag.msgname, 'service_notify')
	self.assertEquals(sbag.body['service_id'], 'sn001')
	self.assertEquals(sbag.body['level'], 0x0002)
	self.assertEquals(sbag.body['weight'], 0x003)
	self.assertEquals(sbag.body['status'], 'D')
	self.assertEquals(cbag.msgname, 'service_notify_resp')
	self.assertEquals(cbag.body['status'], SUCCESS)
